HDU-1160_FatMouse's Speed

FatMouse's Speed

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)
Special Judge

Problem Description

FatMouse believes that the fatter a mouse is, the faster it runs. To disprove this, you want to take the data on a collection of mice and put as large a subset of this data as possible into a sequence so that the weights are increasing, but the speeds are decreasing.

Input

Input contains data for a bunch of mice, one mouse per line, terminated by end of file.

The data for a particular mouse will consist of a pair of integers: the first representing its size in grams and the second representing its speed in centimeters per second. Both integers are between 1 and 10000. The data in each test case will contain information for at most 1000 mice.

Two mice may have the same weight, the same speed, or even the same weight and speed.

Output

Your program should output a sequence of lines of data; the first line should contain a number n; the remaining n lines should each contain a single positive integer (each one representing a mouse). If these n integers are m[1], m[2],..., m[n] then it must be the case that

W[m[1]] < W[m[2]] < ... < W[m[n]]

and

S[m[1]] > S[m[2]] > ... > S[m[n]]

In order for the answer to be correct, n should be as large as possible.
All inequalities are strict: weights must be strictly increasing, and speeds must be strictly decreasing. There may be many correct outputs for a given input, your program only needs to find one.

Sample Input

6008 1300
6000 2100
500 2000
1000 4000
1100 3000
6000 2000
8000 1400
6000 1200
2000 1900

Sample Output

4
4
5
9
7

题意:输入一组(wi,vi)然后找出其中最长的w是上升但是v是下降的序列,并输出,如果有多组,输出一组就可以,
题解:这道题把w按照升序排列出来,然后找出v的最长下降子序列。

#include <algorithm>
#include <iostream>
#include <cstring>
#include <cstdlib>
#include <cstdio>
#include <queue>

using namespace std;

struct node
{
    int w, s, num;
    bool operator<(node x)/*重构<,相当于一个cmp函数,可以直接用sort()*/
    {
        return w < x.w;
    }
}s[1005];

int last[1050],dp[1050];/*last[],存储当前节点的上一个几点,dp的值从谁继承过来就存储谁*/

void show(int i)/*递归输出*/
{
    if(i==-1)
        return;
    show(last[i]);
    printf("%d
",s[i].num);
}

int main()
{
    int i,j,Max,k,n;
    n = 0;
    while(scanf("%d%d",&s[n].w,&s[n].s)!=EOF)
    {
        dp[n] = 1;
        last[n] = -1;
        s[n].num = n + 1;
        n++;
    }
    sort(s,s+n);/*因为有了重构的函数,所以可以不用再写cmp*/
//    printf("
");
//    for(i=0;i<n;i++)
//        printf("%d %d
",s[i].w,s[i].s);
    for(i=0;i<n;i++)
    {
        Max = 0;
        k = -1;
        for(j=0;j<n;j++)
            if(s[j].w<s[i].w&&s[j].s>s[i].s)
            {
                if(dp[j]>Max)
                {
                    Max = dp[j];
                    k = j;
                }
            }
        dp[i] = Max + 1;
        last[i] = k;
    }
    Max = 0;k = -1;
    for(i=0;i<n;i++)
    {
        if(dp[i]>Max)
        {
            Max = dp[i];
            k = i;
        }
    }
    printf("%d
",Max);
    show(k);
    return 0;
}
原文地址:https://www.cnblogs.com/luoxiaoyi/p/9858703.html